"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from circlemind_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing_extensions import Annotated, NotRequired, TypedDict


class InsertRequestTypedDict(TypedDict):
    r"""Data model for insert request."""

    memory: str
    r"""Raw text to be inserted into the graph"""
    metadata: NotRequired[Nullable[str]]
    r"""Stringified JSON dictionary containing any metadata to link to the given memory.

    (i.e., `'{\"id\": \"asdash-234fdsc-erwer-wqes2\", \"url\": \"https://example.com\"}'`)
    """
    memory_id: NotRequired[Nullable[str]]
    r"""Reserved"""


class InsertRequest(BaseModel):
    r"""Data model for insert request."""

    memory: str
    r"""Raw text to be inserted into the graph"""

    metadata: OptionalNullable[str] = UNSET
    r"""Stringified JSON dictionary containing any metadata to link to the given memory.

    (i.e., `'{\"id\": \"asdash-234fdsc-erwer-wqes2\", \"url\": \"https://example.com\"}'`)
    """

    memory_id: Annotated[OptionalNullable[str], pydantic.Field(alias="memoryId")] = (
        UNSET
    )
    r"""Reserved"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["metadata", "memoryId"]
        nullable_fields = ["metadata", "memoryId"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
