"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from circlemind_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict


class QueryRequestTypedDict(TypedDict):
    r"""Data model for query request."""

    query: str
    parameters: NotRequired[Nullable[str]]
    r"""Optional stringified JSON parameters:
    - only_context (bool = false): return only the context of the query instead of processing it via an LLM;
    - with_references (bool = false): include references in the response.

    (i.e., `'{\"only_context\": true}'`)
    """


class QueryRequest(BaseModel):
    r"""Data model for query request."""

    query: str

    parameters: OptionalNullable[str] = UNSET
    r"""Optional stringified JSON parameters:
    - only_context (bool = false): return only the context of the query instead of processing it via an LLM;
    - with_references (bool = false): include references in the response.

    (i.e., `'{\"only_context\": true}'`)
    """

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["parameters"]
        nullable_fields = ["parameters"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
